require "enet"
require "stc"
local UUID = require "UUID"

local playerTable = {nil}
local selfPeer = false
local connected = false
local started = false
local sendTimer = 0
local id = nil

local test1 = false
local stringTest = ""
local sentCount = 0

local host = enet.host_create()
local server = host:connect("localhost:12345")

function connect(event)
	if event and event.type == "connect" then
		selfPeer = event.peer
		selfPeer:send("startup")
		connected = true
		sendTimer = .05
		
		test1 = true
	end
end

function dataReceive(event)
	if event and event.type == "receive" then
		local cmd = event.data:match("^(%S*)")
		if cmd == "playertable" then
			local tableData = event.data:sub(13)
			playerTable = stctable(tableData)
		end
		if cmd == "started" then
			started = true
			id = event.data:match("^%S* (%S*)")
		end
	end
end

function movementSend()
	local wIn = love.keyboard.isDown("w")
	local sIn = love.keyboard.isDown("s")
	local aIn = love.keyboard.isDown("a")
	local dIn = love.keyboard.isDown("d")
	selfPeer:send("inputsend " .. tostring(id) .. " " .. tostring(wIn) .. " " .. tostring(sIn) .. " " .. tostring(aIn) .. " " .. tostring(dIn))
	stringTest = "inputsend " .. tostring(id) ..  " " .. tostring(wIn) .. " " .. tostring(sIn) .. " " .. tostring(aIn) .. " " .. tostring(dIn)
	sentCount = sentCount + 1
end

function love.update(dt)
	sendTimer = sendTimer - dt
	
	local event = host:service()
	if connected then
		dataReceive(event)
		if sendTimer <= 0 then
			movementSend()
		end
	else
		connect(event)
	end
end

function love.draw()
	love.graphics.print(tostring(connected), 10, 10)
	love.graphics.print(tostring(started), 10, 30)
	love.graphics.print(tostring(id), 10, 50)
	love.graphics.print(tostring(test1), 10, 70)
	love.graphics.print(tostring(stringTest), 10, 90)
	if selfPeer then
		love.graphics.print(tostring(selfPeer:round_trip_time()), 10, 110)
	end
	
	love.graphics.print(tostring(sentCount), 10, 130)
	
	if playerTable[1] then
		for i = 1, table.getn(playerTable) do
			love.graphics.rectangle("fill", playerTable[i][1], playerTable[i][2], 32, 32)
		end
	end
end